package controller;

import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Deque;
import java.util.Iterator;

import controller.model.Turn;
import controller.model.Turn.Direction;

import champ2011client.Action;
import champ2011client.SensorModel;




//usage
/*
 * double straightSensors[] = new double[] {trackEdgeSensors[1],trackEdgeSensors[2],trackEdgeSensors[9],trackEdgeSensors[16],trackEdgeSensors[17]};
 * firstLapSteer(SimpleNoisyRemover.average(straightSensors),sm.getTrackEdgeSensors[max],sm.getAngleToTrackAxis(),sm.getTrackPosition());
 */

public class DriveModul {
	
	//vseobecne vyuzivane premenne
	//sirka trate 
	private double trackWidth= 0;
	private ArrayList<Integer> straightSensorIndexes= new ArrayList<Integer>();
	
	//premenne pre jazdu v provom kole firstlapsteer
	private boolean straightMid =false; //hovori o tom ci je na strede rovnobezne s osou 
	
	private boolean rovinaNemeratZakruty = false; //hovori ci je na rovine alebo v zakrute
	
	private Deque<Integer> turnDirection = new ArrayDeque<Integer>();
	
	//premenne vyuzivane pri merani frikcie
	private double friction;
	
	//rychlost po dosiahnuti ktorej sa ma brzdit da sa nastavit cez konstruktor
	private double breakSpeed;
	//miesto zaciatku brzdenia
	private double brakeStartDist;
	//brzdi, flag znaciaci ze pri merani frikcie sme uz vo faze brzdenia
	private boolean brzdi = false;
	//flag hovoriaci ze asuto stoji uudaje su nameran staci iba vypocitat frikciu
	private boolean vypocitajFriction = false;
	//flag hovoriaci o tom ze sme pri brzdeni vo faze kedy sa nam zasekli kolesa 
	private boolean kolesaStoja = false;
	
	//premenne pre radenie
	//premenna oznacujuca dobu v tikoch kedy sa nesmie radit
	private int dontGear =0;
	//
	private double clutchCur=0;
	//
	private Deque<Double> rpm30Tick = new ArrayDeque<Double>();
	
	//-----variables used in launchAssistSteer-----
	//hold the wanted value of track position during launch
	private double launchTrackPos=-3d;
	//holds value of track position on start
	private double startingTrackPos=-3d;
	//index of the sensor that sees oponent
	private double startAssistSensorLastIndex=-1;
	//tick counter used in launchAssistSteer, its value should be set to 20
	private int launchAssistSteer=0;
	private double lastOppPos=0.1;
	private double MIN_CAR_DISTANCE=1.96;
	private double ACCEL_ADJUSTMENT=0;
	private static double OK_POS_ADJUSTMENT=0.03;
	private static double WRONG_WAY_POS_ADJUSTMENT=0.06;
	
	//premenne vyuzivane pri normal steer
	private double lastSteer=0;
	
	/**
	 * defaultny konstuktor naplna rychlost pri ktorej merat frikciu na 125, straight indexes 1,2,16,17,
	 * 
	 */
	public DriveModul(){
		this.breakSpeed=125;
		friction=16;
		ArrayList<Integer> def= new ArrayList<Integer>();
		def.add(1);
		def.add(2);
		def.add(16);
		def.add(17);
		setStraightSensorIndexes(def);
		
	}
	/*
	 * 
	 */
	public DriveModul(double breakSpeed){
		this.breakSpeed=breakSpeed;
	}
	 /**
     * adjust the steer so that the driver goes on the nearest edge of the track, pricom steering adjustment upravuje steer
     * @param sm
     * @param steeradjustmnet nieje implementovane
     * @return steer
     */
    public double launchAssitSteer(SensorModel sm,double steeradjustmnet){
    	double steer;
    	double mypos=0;
    	if(startingTrackPos==-3d){
    		startingTrackPos=sm.getTrackPosition();
    		//System.out.println(startingTrackPos);
    	}
    	if(launchTrackPos==-3d){
    		
    		//launchTrackPos=(trackWidth/2-1.35)/(trackWidth/2);
    		/*if(trackWidth<=12){
    			//launchTrackPos=(trackWidth/2-0.98)/(trackWidth/2);
    			mypos=(trackWidth/2)*Math.abs(sm.getTrackPosition());
        		launchTrackPos=(mypos+0.1)/(trackWidth/2);
    		}
    		else if(trackWidth>=15){
    			mypos=(trackWidth/2)*Math.abs(sm.getTrackPosition());
        		launchTrackPos=(mypos+0.1)/(trackWidth/2);
    		}else{
    			mypos=(trackWidth/2)*Math.abs(sm.getTrackPosition());
        		launchTrackPos=(mypos+MIN_CAR_DISTANCE)/(trackWidth/2);
    		}*/
    		mypos=(trackWidth/2)*Math.abs(sm.getTrackPosition());
    		launchTrackPos=(mypos+0)/(trackWidth/2);
    		//System.out.println(trackWidth);
    		launchTrackPos=launchTrackPos*(Math.abs(sm.getTrackPosition())/sm.getTrackPosition());
    		System.out.println("hm: "+launchTrackPos+" mypos: "+mypos+" trackpos: "+MIN_CAR_DISTANCE);
    	}
    	//vypocitava track pos oponenta fail dost
    	/*	launchAssistSteer--;
    	//&& isAngleToTrackAxisSmall(sm)
    	if((startAssistSensorLastIndex!=isOppInCloseArea(sm) || launchAssistSteer<0) ){
    		
    		//po 20 tikoch kontrolujem oponentovu trackpos
    		//launchAssistSteer=20;
    		if(isOppInCloseArea(sm)!=-1){
    			launchTrackPos=calculateNewTrackPos(sm,isOppInCloseArea(sm),startAssistSensorLastIndex);
    			startAssistSensorLastIndex=isOppInCloseArea(sm);
    			launchAssistSteer=1;
    			System.out.println("som v normalne: "+launchTrackPos);
    		}else
    			startAssistSensorLastIndex=-1;
    		//startAssistSensorLastIndex=isOppInCloseArea(sm);
    	}*/
    	//if(isOppInCloseArea(sm)==-1){
    	if(isOppInCloseArea(sm)!=-1){
    		launchTrackPos+=calculTrackPosAdjustment(sm,isOppInCloseArea(sm));
    		//System.out.println("launchPos: "+launchTrackPos+" cardistance: "+MIN_CAR_DISTANCE+" speedadjustment: "+ACCEL_ADJUSTMENT);
    	}
    	else if(isAngleToTrackAxisSmall(sm) ){
    		//System.out.println("18: "+sm.getOpponentSensors()[18]+" 17: "+sm.getOpponentSensors()[17]);
    		if(sm.getOpponentSensors()[18]>4 && sm.getOpponentSensors()[18]<16){
    			mypos=(trackWidth/2)*Math.abs(sm.getTrackPosition());
    			launchTrackPos=(mypos+1*Math.abs(sm.getTrackPosition())/sm.getTrackPosition())/(trackWidth/2);
    			//System.out.println("18: "+sm.getOpponentSensors()[18]);
    		}
    		if(sm.getOpponentSensors()[17]>4 && sm.getOpponentSensors()[17]<16){
    			mypos=(trackWidth/2)*Math.abs(sm.getTrackPosition());
    			launchTrackPos=(mypos-1*Math.abs(sm.getTrackPosition())/sm.getTrackPosition())/(trackWidth/2);
    			//System.out.println("17: "+sm.getOpponentSensors()[17]);
    		}
    	}
    	launchTrackPos=normalizeTrackPos(sm.getTrackPosition());
    	steer=(sm.getAngleToTrackAxis()-(sm.getTrackPosition()-launchTrackPos)*(0.5+ACCEL_ADJUSTMENT))/0.366519;
    	
    	//}else{
    	//	steer = avoidCloseOppnent(sm,isOppInCloseArea(sm),sm.getTrackPosition());
    		//System.out.println("-------------------------------------------som v else avoid opponent: "+sm.getAngleToTrackAxis());
    	//}
    	
    	return steer;
    }
    /**
     * fixne hodnotu ak prekroci hranicne hodnoty
     * @param trackPos
     * @return
     */
    private double normalizeTrackPos(double trackPos){
    	double trackWidthAdjustment=0;
    	if(trackWidth<=12)
    		trackWidthAdjustment=1;
    	else if(trackWidth<=10)
    		trackWidthAdjustment=1;
    	
    	if(trackPos>1-(0.98-trackWidthAdjustment)/(trackWidth/2))
    		return 1-(0.98-trackWidthAdjustment)/(trackWidth/2);
    	if(trackPos<-1+(0.98-trackWidthAdjustment)/(trackWidth/2))
    		return -1+(0.98-trackWidthAdjustment)/(trackWidth/2);
    	return launchTrackPos;
    }
    /**
     * ak je uhol k osi mensi ako 0.01 rad
     * @param sm
     * @return
     */
    private boolean isAngleToTrackAxisSmall(SensorModel sm){
    	return (sm.getAngleToTrackAxis()<0.01 && sm.getAngleToTrackAxis()>-0.01);
    }
    /**
     * determins wheather some oponent is in close area and returns index of sensor that sees him
     * @param sm
     * @return index of the senzor that show opponent in close area
     */
    private int isOppInCloseArea(SensorModel sm){
    	if(sm.getOpponentSensors()[9]<3)
    		return 9;
    	if(sm.getOpponentSensors()[12]<3)
    		return 12;
    	if(sm.getOpponentSensors()[14]<5)
    		return 14;
    	if(sm.getOpponentSensors()[15]<7)
    		return 15;
    	if(sm.getOpponentSensors()[16]<(14))
    		return 16;
        if(sm.getOpponentSensors()[17]<15)
        	return 17;
        if(sm.getOpponentSensors()[18]<15)
        	return 18;
        if(sm.getOpponentSensors()[19]<14)
        	return 19;
        if(sm.getOpponentSensors()[20]<7)
        	return 20;
        if(sm.getOpponentSensors()[21]<5)
        	return 21;
        if(sm.getOpponentSensors()[23]<3)
        	return 23;
        if(sm.getOpponentSensors()[26]<3)
        	return 26;
        return -1;
    }
    private double calculTrackPosAdjustment(SensorModel sm,int index){
    	double adjustment =0;
    	//System.out.print("sensor: "+sm.getOpponentSensors()[index]+" index: "+index+" ");
    	if(sm.getOpponentSensors()[index]>(MIN_CAR_DISTANCE/0.191) && (index ==17 || index ==18)){
    		adjustment=0;
    		ACCEL_ADJUSTMENT=0;
    	}else
    	//mal by to byt 16 alebo 19	
    	if(sm.getOpponentSensors()[index]<(MIN_CAR_DISTANCE/0.191) && sm.getOpponentSensors()[index]>(MIN_CAR_DISTANCE/0.358) ){
    		if(index <=16 ){
    			adjustment=-OK_POS_ADJUSTMENT/3;
    			ACCEL_ADJUSTMENT=0;
    		}else if(index >=19){
    			adjustment=OK_POS_ADJUSTMENT/3;
    			ACCEL_ADJUSTMENT=0;
    		}else if(index == 17){
    			if(isSpaceNewRight(sm.getTrackPosition(),MIN_CAR_DISTANCE,0)){
    				adjustment=-OK_POS_ADJUSTMENT;
    				
    			}else
    				adjustment=WRONG_WAY_POS_ADJUSTMENT;
    			ACCEL_ADJUSTMENT=0.1;
    		}else if(index ==18){
    			if(isSpaceNewLeft(sm.getTrackPosition(),MIN_CAR_DISTANCE,0)){
					adjustment=OK_POS_ADJUSTMENT;
				}else
					adjustment=-WRONG_WAY_POS_ADJUSTMENT;
    			ACCEL_ADJUSTMENT=0.1;
    		}
    		
    	}
    	//ma lby to byt 15 alebo 20
    	if(sm.getOpponentSensors()[index]<(MIN_CAR_DISTANCE/0.358) && sm.getOpponentSensors()[index]>(MIN_CAR_DISTANCE/0.515) ){
    		if(index <=15 ){
    			adjustment=-OK_POS_ADJUSTMENT/4;
    			ACCEL_ADJUSTMENT=0;
    		}else if(index >=20){
    			adjustment=OK_POS_ADJUSTMENT/4;
    			ACCEL_ADJUSTMENT=0;
    		}else if(index >15 && index <=17){
    			if(isSpaceNewRight(sm.getTrackPosition(),MIN_CAR_DISTANCE-0.77,0)){
    				adjustment=-OK_POS_ADJUSTMENT*Math.pow(2, index-15);
    			}else
    				adjustment=WRONG_WAY_POS_ADJUSTMENT*Math.pow(2, index-15);
    			ACCEL_ADJUSTMENT=0.1*(index-15);
    		}else if(index <20 && index >=18){
    			if(isSpaceNewLeft(sm.getTrackPosition(),MIN_CAR_DISTANCE-0.77,0)){
					adjustment=OK_POS_ADJUSTMENT*Math.pow(2, 20-index);
				}else
					adjustment=-WRONG_WAY_POS_ADJUSTMENT*Math.pow(2, 20-index);
    			ACCEL_ADJUSTMENT=0.1*(20-index);
    		}
    		
    	}
    	
    	if(sm.getOpponentSensors()[index]<(MIN_CAR_DISTANCE/0.515)  ){
    		if(index <=14){
    			adjustment=-OK_POS_ADJUSTMENT/5;
    			ACCEL_ADJUSTMENT=0;
    		}else if(index >=21){
    			adjustment=OK_POS_ADJUSTMENT/5;
    			ACCEL_ADJUSTMENT=0;
    		}else if(index >14 && index <=17){
    			if(isSpaceNewRight(sm.getTrackPosition(),MIN_CAR_DISTANCE-1.13,0)){
    				adjustment=-OK_POS_ADJUSTMENT*Math.pow(2, index-14);
    			}else
    				adjustment=WRONG_WAY_POS_ADJUSTMENT*Math.pow(2, index-14);
    			ACCEL_ADJUSTMENT=0.1*(index-14);
    		}else if(index <21 && index >=18){
    			if(isSpaceNewLeft(sm.getTrackPosition(),MIN_CAR_DISTANCE-1.13,0)){
					adjustment=OK_POS_ADJUSTMENT*Math.pow(2, 21-index);
				}else
					adjustment=-WRONG_WAY_POS_ADJUSTMENT*Math.pow(2, 21-index);
    			ACCEL_ADJUSTMENT=0.1*(21-index);
    		}
    	}
    	/*if(sm.getOpponentSensors()[index]<(MIN_CAR_DISTANCE/0.515)  ){
    		if(index <=14 || index >=21){
    			adjustment=0;
    			ACCEL_ADJUSTMENT=0;
    		}else if(index >14 && index <=17){
    			if(isSpaceNewRight(sm.getTrackPosition(),MIN_CAR_DISTANCE-1.13,0)){
    				adjustment=-OK_POS_ADJUSTMENT*Math.pow(2, index-15);
    			}else
    				adjustment=WRONG_WAY_POS_ADJUSTMENT*Math.pow(2, index-15);
    		}else if(index <21 && index >=18){
    			if(isSpaceNewLeft(sm.getTrackPosition(),MIN_CAR_DISTANCE-1.13,0)){
					adjustment=OK_POS_ADJUSTMENT*Math.pow(2, 20-index);
				}else
					adjustment=-WRONG_WAY_POS_ADJUSTMENT*Math.pow(2, 20-index);
    		}
    	}*/
    	if(sm.getOpponentSensors()[index]<(MIN_CAR_DISTANCE/0.875)  ){
    		if(index <=12 || index >=23){
    			adjustment=0;
    			
    		}else if(index >12 && index <=17){
    			if(isSpaceNewRight(sm.getTrackPosition(),MIN_CAR_DISTANCE-1.96,0.5)){
    				adjustment=-OK_POS_ADJUSTMENT*Math.pow(2, index-15);
    			}else
    				adjustment=WRONG_WAY_POS_ADJUSTMENT*Math.pow(2, index-15);
    		}else if(index <23 && index >=18){
    			if(isSpaceNewLeft(sm.getTrackPosition(),MIN_CAR_DISTANCE-1.96,0.5)){
					adjustment=OK_POS_ADJUSTMENT*Math.pow(2, 20-index);
				}else
					adjustment=-WRONG_WAY_POS_ADJUSTMENT*Math.pow(2, 20-index);
    		}
    		ACCEL_ADJUSTMENT=0;
    	}
    	if(sm.getOpponentSensors()[index]<(MIN_CAR_DISTANCE)  ){
    		if(index <=9 || index >=26){
    			adjustment=0;
    			
    		}else if(index >9 && index <=17){
    			if(isSpaceNewRight(sm.getTrackPosition(),MIN_CAR_DISTANCE-2.26,0.8)){
    				adjustment=-OK_POS_ADJUSTMENT*Math.pow(2, index-15);
    			}else
    				adjustment=WRONG_WAY_POS_ADJUSTMENT*Math.pow(2, index-15);
    		}else if(index <26 && index >=18){
    			if(isSpaceNewLeft(sm.getTrackPosition(),MIN_CAR_DISTANCE-2.26,0.8)){
					adjustment=OK_POS_ADJUSTMENT*Math.pow(2, 20-index);
				}else
					adjustment=-WRONG_WAY_POS_ADJUSTMENT*Math.pow(2, 20-index);
    		}
    		ACCEL_ADJUSTMENT=0;
    	}
    		
    		
    		
    	return 	adjustment;
    }
    private boolean isSpaceNewRight(double pos,double width,double adjustment){
    	double trackWidthAdjustment=0;
    	if(trackWidth<=12)
    		trackWidthAdjustment=1;
    	else if(trackWidth<=10)
    		trackWidthAdjustment=1;
    	if(pos>0)
    		return true;
    	return ((trackWidth)/2)*Math.abs(pos)+width<((trackWidth)/2-0.98+trackWidthAdjustment+adjustment);
    }
    private boolean isSpaceNewLeft(double pos,double width,double adjustment){
    	double trackWidthAdjustment=0;
    	if(trackWidth<=12)
    		trackWidthAdjustment=1;
    	else if(trackWidth<=10)
    		trackWidthAdjustment=1.0;
    	if(pos<0)
    		return true;
    	return ((trackWidth)/2)*Math.abs(pos)+width<((trackWidth)/2-0.98+trackWidthAdjustment+adjustment);
    }
	/**
	 *  metoda na nastavanie steeringu v prvom kole, zatial sa vyuziva ja v ostatnych kolach,
	 * okrem to ho ze vracia steering upravuje a hodnoty globalnych premenny ako rovinaNemeratZakruty, turnDirection 	
	 *	
	 * @param trackEdgeSensorsStraight
	 * @param trackEdgeSensorsMax
	 * @param angleToTrackAxis
	 * @param trackPosition
	 * @param max index najdlhsieho senzora
	 * @return
	 */
	public double firstLapSteer(double trackEdgeSensorsStraight,double trackEdgeSensorsMax,double angleToTrackAxis,double trackPosition,int max){
		//TODO vynulovat que smeru po zmene smeru
		
		double steer=0;
		//int max=0;
		//netreba zistovat maximum lebo ho mame ako parameter
		/*for (int i = 1; i < trackEdgeSensors.length; i++)
			if (trackEdgeSensorsMax < trackEdgeSensors[i] && i!=1 && i!=2 && i!=16 && i!=17)
				max = i;*/
		int uhol= 0;	
		//boolean pre vytvaranie modelu 
		if(straightMid && (angleToTrackAxis<-0.001 || angleToTrackAxis>0.001)  && (trackPosition>0.01 || trackPosition<-0.01))
			rovinaNemeratZakruty=false;
		
		//System.out.println("lavo: "+sm.getTrackEdgeSensors()[8]+"stredny: "+sm.getTrackEdgeSensors()Straight+" pravo: "+sm.getTrackEdgeSensors()[10]);
		
		if(max<9  && ((trackEdgeSensorsMax-trackEdgeSensorsStraight)>trackWidth || trackEdgeSensorsMax<2*trackWidth || turnDirection.getFirst()!=0) ){
			uhol=1;
			
		}
		else if(max>9 && ((trackEdgeSensorsMax-trackEdgeSensorsStraight)>trackWidth || trackEdgeSensorsMax<2*trackWidth || turnDirection.getFirst()!=0) ){
			uhol=-1;
			
		}
		else{
			uhol =0;
		}
		//uhol v predchadzjucom tiku prenasobeny -1 aby pri porovnani s uhlom v akt tiku bol rovnaky ak bola preskocena nula
		int uholLast=getTurnDirection(turnDirection)*-1;
		if(turnDirection.size()==5)
			turnDirection.pollFirst();
		turnDirection.addLast(uhol);
		uhol =getTurnDirection(turnDirection);
		//System.out.println(uhol);
		//zenil sa smer zakruty bez toho aby bola zaregistrovana 0
		if(uhol==uholLast){
			rovinaNemeratZakruty=true;
			uhol =0;
		}
		//zaregistroval som smer rovina
		else if(uhol==0){
			rovinaNemeratZakruty=true;
			straightMid=false;
		}else if(uhol!=0)//som v zakrute nastavim straightMid na true aby som zakrutu registroval
			straightMid=true;
		//System.out.println("uhol: "+uhol);
		//if(!rovinaNemeratZakruty)
			//System.out.println(sm.getAngleToTrackAxis());
		if(!rovinaNemeratZakruty && straightMid){
			//if(!(sm.getAngleToTrackAxis()>-0.001 && sm.getAngleToTrackAxis()<0.001)&& uhol !=0 ){
				
				steer=(steeringAdjustmentNew(trackEdgeSensorsStraight,(trackWidth),0)*(uhol) -(trackPosition*0.1)/0.366519);
				//System.out.println(sm.getTrackEdgeSensors()[1]+" "+sm.getTrackEdgeSensors()[2]+" "+sm.getTrackEdgeSensors()Straight);
			}else {
					steer=(angleToTrackAxis-trackPosition*0.2)/0.366519;
			}
		
		//odstartoval je rovnobezne s osou a na strede trate
		if (!straightMid && (angleToTrackAxis>-0.001 && angleToTrackAxis<0.001) && trackPosition<0.02 && trackPosition>-0.02)
			straightMid=true;
		else
			steer=(angleToTrackAxis-trackPosition*0.5)/0.366519;
		
		lastSteer =steer;
		return steer;
	}
	
	/**
	 * metoda na zistenie frikcie z brzdnej drahy pri zaseknutych kolesach(vsetky4),
	 *  pouziva v sebe globalne premenne breakSpeed(125), breakStartDist a tri 
	 *  flagy a to vypocitajFriction, brzdi, kolesaStoja
	 *  
	 * @param wheelSpinVelocity pole s rychlostami kolies
	 * @param speed aktualna rychlost vozidla
	 * @param distanceRaced prejdena trasa
	 * @param action aktualna akcia
	 * @return akcia upravena podla potreby pre meranie frikcie
	 */
    public Action getFriction(double[] wheelSpinVelocity,double speed,double distanceRaced, Action action){
    	
		
		if(speed<=breakSpeed && !brzdi){
			action.accelerate=1;
			action.brake=0;
			brakeStartDist = distanceRaced;
			//System.out.println(brakeS);
		}else{
			action.steering=0;
			double avgWheelSpeed =0;
			//System.out.print(zrychlenie(sensorsBefore.getSpeed(), sensors.getSpeed(), sensorsBefore.getCurrentLapTime(), sensors.getCurrentLapTime()));
			//System.out.print(" =||= ");
			for(int i=0;i<4;i++){
				avgWheelSpeed+=wheelSpinVelocity[i]*0.3179;
				//System.out.print(" || "+zrychlenie(sensorsBefore.getWheelSpinVelocity()[i]*0.3179, sensors.getWheelSpinVelocity()[i]*0.3179, sensorsBefore.getCurrentLapTime(), sensors.getCurrentLapTime()));
			}
			avgWheelSpeed/=4;
			//System.out.println();
			//System.out.println("rychlost kolies: "+speed +" brakespeed "+breakSpeed+" brakedist "+brakeStartDist);
			
			if(avgWheelSpeed<0.05 && !kolesaStoja){
				brakeStartDist= distanceRaced;
				kolesaStoja=true;
				breakSpeed=speed;
			}
			brzdi=true;
			action.accelerate=0;
			action.brake=1;
			action.clutch=0;
			if(speed<0.01 && !vypocitajFriction){
				//System.out.println("drzdna draha"+(sensors.getDistanceRaced()-brakeStartDist)+ " rychlost kolies: "+speed +" brakespeed "+breakSpeed+" brakedist "+brakeStartDist+" friction "+(Math.pow(breakSpeed, 2)/(2*9.81*(sensors.getDistanceRaced()-brakeStartDist))));
				vypocitajFriction=true;
				System.out.println();
				
				friction= (Math.pow(breakSpeed, 2)/(2*9.81*(distanceRaced-brakeStartDist)));
				System.out.println("friction: "+friction);
			}
			
		}
		//friction= 16;
		return action;
	}
    
    public double getFriction(){
    	return friction;
    }
    /**
     * metoda modulu riadenia na urcenie prevodoveho stupna s otacok motora a podla toho ci rastu/klesaju
     * zahrnuje v seba aj line assist
	 * 
     * @param sensors senzory vozidla podla specifikacie torcs 2010
     * @param action akciu ktora sa vykonava
     * @return obohatenu akciu o nastaveny prevodovy stupen a spojku, v pripade ze je auto na starte riadi aj akceleraciu v ramci startassistu
     */
    public Action getGear(SensorModel sensors,Action action){
		int gearCur;
		double rpm = sensors.getRPM(),lastRpm=9000;
		int[]  gearUp = {9500, 9500, 9500, 9500, 9500, 0};
		int[]  gearDown =  {0, 4300, 6200, 7000, 7300, 7700};
		gearCur=sensors.getGear();//berem akt stupen
		
		//updatne sa zoznam otacok za poslednych 30 tikov
		if(rpm30Tick.size()>0)
			lastRpm=rpm30Tick.getLast();
		if(rpm30Tick.size()==30 && dontGear==0)
			rpm30Tick.pollFirst();
		if(dontGear==0)
			rpm30Tick.addLast(rpm);
		else
			dontGear--;
		
		//som na starte a pretek este nebol odstarovany radim 1, stlacim spojku, pridam plyn 
		if(gearCur<1){
			gearCur=1;
			action.gear=gearCur;
			action.accelerate= 1-ACCEL_ADJUSTMENT;
			clutchCur=0.9;
			//dontGear=8;
		}
		//uz je odstartovane a mam stlacenu spojku, zaradenu 1, ak otack rastu a su nad  9000 tak uberam spojku po 0.05, ak klesnu pod 7000 uberam iba po 0.02 ak klesnu pod 6500 pridavam k spojke po 0.01
		//podmienka clutchCur>0.67 a akcia clutchCur-=0.34;
		//TODO ked bude asr s nastavitelni smykom tak zmeni podmienku s casom a dat namiesto acc 1 asr
		else if(((clutchCur>0.05 && gearCur==1 )|| sensors.getSpeed()<55) && sensors.getCurrentLapTime()<3.5 && sensors.getLastLapTime()==0){
			action.accelerate=1-ACCEL_ADJUSTMENT;
			//if((rpm-lastRpm)>=0 && rpm > 9300 && sensors.getSpeed()<40)
			//	clutchCur-=0.08;
			//else 
			if((rpm-lastRpm)>=0 && rpm > 9000)
				clutchCur-=0.05;
			else if((rpm-lastRpm)>=0 && rpm > 7000)
				clutchCur-=0.02;
			else if(rpm < 6500)
				clutchCur+=0.01;
			//System.out.println("som tu");
		}else if(clutchCur>0 && (rpm-lastRpm)>0 && rpm>7000 && gearCur==1 && rpm<9499){
			clutchCur-=0.03;
			//System.out.println("lol");
		}
		// rychlost je mensia ako 6 sucastne su otaky vecsie/rovne otackam ked radim, a sucasne otacky v predchadzajucich 30 tikoch stupali => radim hore
		else if (gearCur < 6 && rpm >= gearUp[gearCur-1] && dontGear==0)
		{	
			if(gearCur==1)
				clutchCur=0.63;
			if(isDequeGrowing(rpm30Tick)){
				dontGear=8;
				gearCur++;
			}
		}
		// rychlost je vetsia ako 1 sucastne su otaky mensie/rovne otackam ked podradzujem a otacky za poslednych 30 tikov klesaju
		else if (gearCur > 1 && rpm <= gearDown[gearCur-1]  && dontGear==0 )
		{
			if(!isDequeGrowing(rpm30Tick)){
				dontGear=8;
				gearCur--;	
			}
		} 
			if (sensors.getSpeed()>78 && gearCur == 1){
				clutchCur=0.63;
				dontGear=8;
				gearCur++;
			}	
		//mam zaradenu inu rychlost ako 1 a spojka je stlacena, ak je zaradena dvojka tak pustam spojku ak su otacky nad 6500 ak je ina rychlost tak pustam spojku
		if((clutchCur>0 && gearCur>1 && (rpm-lastRpm)>0) || rpm>9000 && gearCur>1){
			if(gearCur==2 && rpm>7000)
				clutchCur-=0.01;
			else if(gearCur==2 && rpm>8500)
				clutchCur-=0.08;
			else if (gearCur!=2){
				clutchCur-=0.15;
				
			}
		}
		//System.out.println(rpm);
		if(sensors.getCurrentLapTime()<6 && sensors.getLastLapTime()==0)
			action.accelerate=1-ACCEL_ADJUSTMENT;
		action.gear=gearCur;
		action.clutch=clutchCur;
		return action;
	}
    
    public double steerNormal(double[] trackEdgeSensors,double distanceFromStartLine,double angleToTrackAxis,double trackPosition,Turn aktTurn,double lastTurnEnd, boolean isTurnFront){
    	straightMid=true;
    	double steer=0;
		//double[] prekrytesenzory = prekriOpponentSenzorySTrackEdge(sm.getOpponentSensors(),sm.getTrackEdgeSensors(),25.0,sm);
		
		double uhol = -computeAvgLongestSensorAngle(trackEdgeSensors);
		double[]  maxSteers = {0,0.25, 0.38, 0.48,0.68,0.70,0.85,1,1,1 };
		int maxSteerIndex=(int)Math.abs(uhol)/10;
		//smer zakruty
		int dir = ((int) (Math.abs(uhol)/uhol));
		//System.out.println("smer: "+dir+" laststeer: "+lastSteer+" ");
		//if(aktTurn.getStartDistance()<sm.getDistanceFromStartLine() && aktTurn.getEndDistance()>sm.getDistanceFromStartLine()){
			//System.out.println("smer: "+dir+" laststeer: "+lastSteer+" steer: "+steer+" uhol: "+uhol);
			if(maxSteers[maxSteerIndex]>Math.abs(lastSteer) ){
				steer=(Math.abs(lastSteer)+0.01*maxSteerIndex)*dir;
			}else 
				steer=(Math.abs(lastSteer)-0.01*maxSteerIndex)*dir;
		//}else if(aktTurn.getStartDistance()-sm.getDistanceFromStartLine()>200 && aktTurn.getPeakValue()>0.25 || aktTurn.getPeakValue()<0.25 && aktTurn.getStartDistance()-sm.getDistanceFromStartLine()>50)
		//	steer=(sm.getAngleToTrackAxis())/0.366519;
		//}else 
		//	steer=0;
		//System.out.println("smer: "+dir+" laststeer: "+lastSteer+" steer: "+steer+" uhol: "+uhol);
		if(lastSteer==0 && steer!=0 && isInTurn(distanceFromStartLine,aktTurn))
			steer=aktTurn.getPeakValue();
			
		if(steer == 0 && lastSteer == 0 && aktTurn.getStartDistance()>distanceFromStartLine && aktTurn.getStartDistance()-distanceFromStartLine>2*trackWidth){
			if(trackPosition>0.5)
				steer=(angleToTrackAxis-0.05)/0.366519;
			else if(trackPosition<-0.5)
				steer=(angleToTrackAxis+0.05)/0.366519;
			
			
		}
		if(uhol ==0 && lastSteer!=0){
			steer=(Math.abs(lastSteer)-0.03)*-(Math.abs(lastSteer)/lastSteer);
			if(lastSteer<0.03 && lastSteer>-0.03)
				steer=0;
		}
			
		//jazda podla osi po strede
		if(aktTurn.getStartDistance()-lastTurnEnd>30 && aktTurn.getStartDistance()-trackWidth*4>distanceFromStartLine && lastTurnEnd<distanceFromStartLine || lastTurnEnd>aktTurn.getStartDistance() || (!isTurnFront && aktTurn.getEndDistance()<distanceFromStartLine)){
			steer=this.tuneSteering((angleToTrackAxis-trackPosition*0.1)/0.366519);
			/*if(trackPosition<-0.8)
				steer=0.05;
			if(trackPosition>0.8)
				steer=-0.05;*/
			//System.out.println("stred >>>>>>>>>>>>>");
		}
		
		if(Math.abs(angleToTrackAxis)<0.17 && aktTurn.getPeakValue()>0.2 && distanceFromStartLine<aktTurn.getEndDistance() && distanceFromStartLine>((aktTurn.getStartDistance()+(aktTurn.getEndDistance()-aktTurn.getStartDistance())/2))) {
			if((aktTurn.getDirection()==Direction.LEFT && trackPosition>0) || (aktTurn.getDirection()==Direction.RIGHT && trackPosition<0))
				{ 
				steer*=0.8;
				//System.out.println("vyjazd >>>>>>>>>>>>>  "+angleToTrackAxis);	
				}
			else if(Math.abs(trackPosition)<0.3) {
				steer*=0.8;
				//System.out.println("vyjazd >>>>>>>>>>>>> *08  "+angleToTrackAxis);	
			}
			else if(Math.abs(trackPosition)<0.4) {
				steer*=0.85;
				//System.out.println("vyjazd >>>>>>>>>>>>> *085  "+angleToTrackAxis);	
			}
			else if(Math.abs(trackPosition)<0.5) {
				steer*=0.9;
				//System.out.println("vyjazd >>>>>>>>>>>>> *09  "+angleToTrackAxis);	
			}
			else if(Math.abs(trackPosition)<0.7) {
				steer*=0.95;
				//System.out.println("vyjazd >>>>>>>>>>>>> *095  "+angleToTrackAxis);	
			}
			else if(Math.abs(trackPosition)>0.8) {
				steer*=1.05;
				//System.out.println("vyjazd >>>>>>>>>>>>> *105  "+angleToTrackAxis);	
			}
			//System.out.println("vyjazd >>>>>>>>>>>>>");
		}
		
		//ak je vozidlo vo viac ako 45 stupnovom uhle s osou trate tak radikalne toci v smere zakruty
		if(angleToTrackAxis>0.8722 && angleToTrackAxis<-0.8722 )
			steer=1*dir;
		
		lastSteer =steer;
		return steer;
		
	}
    
    /**
	 * ladenie steeringu
	 * @param steer
	 * @return
	 */
	private static double tuneSteering(double steer) {
		//ladenie trhaneho pohybu
		if((steer>0 && steer<0.01) || (steer<0 && steer>-0.01))
			return 0;
		if(steer>0.2)
			return 0.2;
		if(steer<-0.2)
			return -0.2;
		else
			return steer;
	}
    
    public void setTrackWidth(double trackWidth){
    	this.trackWidth=trackWidth;
    	System.out.println("trackwidth: "+trackWidth);
    	if(trackWidth>=14){
    		MIN_CAR_DISTANCE+=0.4;
    		
    	}else if(trackWidth>=12){
    		MIN_CAR_DISTANCE+=0.3;
    	}else if(trackWidth>10)
    		MIN_CAR_DISTANCE+=0.2;
    	else{ 
    		MIN_CAR_DISTANCE+=0.1;
    	}
    }
	
	/**
	 *  spocita jednotlive prvky na vypocet smeru za poslednych que.size() tikov
	 * @param que rad integerov
	 * @return sucet hodnout v rade
	 */
	private int getTurnDirection(Deque<Integer> que){
		Iterator<Integer> i = que.iterator();
		int aktValue=0;
		int zeroCount=0,negCount=0,pozCount=0;
		int ret=0;
		while(i.hasNext()){
			aktValue= i.next();
			ret+=aktValue;
			if(aktValue==0)
				zeroCount++;
			
		}
		if(ret>0)
			return 1;
		else if(ret <0)
			return -1;
		else if(zeroCount>=4)
			return 0;
		else
			return aktValue;
	}
	private double steeringAdjustmentNew(double distance,double trackWidth,double strana){
		//TODO prve dva ifi na zaklade sirky trate mozno lepsie na zaklde pozicie na trati
		
		distance=distance-(trackWidth-6);
		
		if(distance<42)
			distance= distance*1.05;
		if(distance<15)
			distance= distance*1.1052;
		//System.out.println(distance);
		
		if(distance>138)
			return 0.0075;
		if(distance>43){
			strana= (0.8409/(distance-26.9920))*(1+(strana));
			//strana =0;
		}else if(distance>15){
			strana= (2.2216/(distance-9.9210))*(0.975+(strana));
		}else if (distance >6.3545)
			strana= (3.8193/(distance-6.3542))*(1+(strana));
		else
			strana =1; 
		if(strana>1)
			strana=1;
		if(strana<-1)
			strana=-1;
		
			
		return Math.abs(strana);
	}
	/**
	 * metoda vrati true ak rad<double> apon s polovice rastie a false ak nsatane opacne situacia
	 * 
	 * @param que rad cisel ktorych rast sa ma urcit
	 * @return true alebo false
	 */
	private boolean isDequeGrowing(Deque<Double> que){
		
		/*if(que.getLast()-que.getFirst()>0)
			return true;
		else
			return false;*/
		
		Deque<Double> pom = new ArrayDeque<Double>(que);
		boolean rastie[] = new boolean[pom.size()];
		double curValue = pom.pollFirst().doubleValue();
		
		for(int i=0;i<que.size()-1;i++){
			rastie [i]= curValue<pom.peekFirst().doubleValue();
			curValue = pom.pollFirst().doubleValue();
			
		}
		
		int h=0;
		for(int i=0;i<rastie.length;i++){
			if(rastie[i])
				h++;
		}
		
		if(h>=rastie.length/2)
			return true;
		else
			return false;
	}
	
	private boolean isInTurn(double distanceFromStartLine, Turn aktTurn){
		if(aktTurn!=null)
			return aktTurn.getStartDistance()<distanceFromStartLine && aktTurn.getEndDistance()>distanceFromStartLine;
		return false;
	}
	
	private double computeAvgLongestSensorAngle(double[] trackEdgeSensors)
	{
		int max = 0, numberOfLongestSensors = 1;
		double angle = 0;

		// najde index prveho senzora v smere k najvzdialenejsiemu okraju trate
		for (int i = 1; i < trackEdgeSensors.length; i++)
			
			if (!isSensorIndexStraight(i) && trackEdgeSensors[max] < trackEdgeSensors[i])
					max = i;
		
		// zisti kolko senzorov ma najvyssiu hodnotu
		while (max + numberOfLongestSensors < trackEdgeSensors.length &&
				trackEdgeSensors[max] == trackEdgeSensors[max + numberOfLongestSensors])
			numberOfLongestSensors++;

		// vypocet priemeru, vysledok je z rozsahu <-90; 90>
		for (int i = 0; i < numberOfLongestSensors; i++)
			angle = max + i;
		angle = (angle / numberOfLongestSensors) * 10 - 90;
		
		return angle;
	}
	/**
	 * urci ci index patri medzi indexy ktore su nastavene rovnobezne s osou vozidla metod bola pisna ked tieto indexy boli 1,2,16,17(ak boli zmenene treba zmenit metodu) aj ked je 9 rovnobezne s osou neurcje juako true
	 * @param i
	 * @return
	 */
	public boolean isSensorIndexStraight(int i){
		Iterator<Integer> iter =straightSensorIndexes.iterator();
		while(iter.hasNext()){
			if(i==iter.next())
				return true;
		}
		return false;
	}
	
	
	
	public boolean isStraightMid() {
		return straightMid;
	}
	public boolean isRovinaNemeratZakruty() {
		return rovinaNemeratZakruty;
	}
	public void setStraightSensorIndexes(Collection<Integer> colection){
		straightSensorIndexes.clear();
		straightSensorIndexes.addAll(colection);
	}
	
	public void setFriction(double friction) {
		this.friction = friction;
	}
	
	/**
	 * metoda na vypocet dlzky z rychlosti pre neskorsi vypocet rychlosti
	 * @param speed
	 * @param friction
	 * @return
	 */
	public static double countDistanceFromSpeed(double speed, double friction) {
		return ((Math.pow(speed+60, 2))/(2*9.81*friction));
	}
	 //metoda ktora v kazdom tiku pocitala opponent track pos zla v tom ked sa menia senzory tak a posuva k oponentovi
    /*private double avoidCloseOppnent(SensorModel sm,int index,double trackPos){
    	double oppTrackPos=0;
    	double ourNewTrackPos;
    	if(index<=17){
    		oppTrackPos=sm.getTrackPosition()+((Math.sin(indexToRad(index))*sm.getOpponentSensors()[index])/(trackWidth/2))*1.15;
    		System.out.println(Math.sin(indexToRad(index))+" "+sm.getOpponentSensors()[index]+" "+ (trackWidth/2));
    		System.out.println("opponent pos: "+oppTrackPos+" my pos: "+trackPos+" index "+index);
    	}
    	else{
    		oppTrackPos=sm.getTrackPosition()-((Math.sin(indexToRad(index))*sm.getOpponentSensors()[index])/(trackWidth/2))*1.15;
    		System.out.println(Math.sin(indexToRad(index))+" "+sm.getOpponentSensors()[index]+" "+ (trackWidth/2));
    		System.out.println("opponent pos: "+oppTrackPos+" my pos: "+trackPos+" index "+index);
    	}
    	//oppTrackPos=Math.abs(oppTrackPos);
    	
    	
    	//oponent je na lavo a na lavo je dost miesta
    	if(index<17 && isSpace(oppTrackPos,index-13) && trackPos>oppTrackPos){
    		launchTrackPos=ourNewTrackPos=sampleTrackPos(launchTrackPos,((trackWidth/2)*oppTrackPos+2.5)/(trackWidth/2));
    		System.out.println(" 1 newtrackpos "+ourNewTrackPos);
    		return 2*(sm.getAngleToTrackAxis()-(sm.getTrackPosition()-ourNewTrackPos))/0.366519;
    	}
    	else if(index<17 && isSpace(oppTrackPos,index-13) && trackPos<oppTrackPos){
    		launchTrackPos=ourNewTrackPos=sampleTrackPos(launchTrackPos,((trackWidth/2)*oppTrackPos+2.5)/(trackWidth/2));
    		System.out.println(" 2 newtrackpos "+ourNewTrackPos);
    		return 2*(sm.getAngleToTrackAxis()-(sm.getTrackPosition()-ourNewTrackPos))/0.366519;
    	}
    	//oponent je na lavo a neni tam dost miesta
    	else if(index<17 && !isSpace(oppTrackPos,index-13)&& trackPos>oppTrackPos){
    		launchTrackPos=ourNewTrackPos=sampleTrackPos(launchTrackPos,((trackWidth/2)*oppTrackPos-2.5)/(trackWidth/2));
    		System.out.println(" 3 newtrackpos "+ourNewTrackPos);
    		return 2*(sm.getAngleToTrackAxis()-(sm.getTrackPosition()-ourNewTrackPos))/0.366519;
    	}
    	else if(index<17 && !isSpace(oppTrackPos,index-13)&& trackPos<oppTrackPos){
    		launchTrackPos=ourNewTrackPos=sampleTrackPos(launchTrackPos,((trackWidth/2)*oppTrackPos-2.5)/(trackWidth/2));
    		System.out.println(" 4 newtrackpos "+ourNewTrackPos);
    		return -(sm.getAngleToTrackAxis()-(sm.getTrackPosition()-ourNewTrackPos))/0.366519;
    	}
    	//oponent je na pravo a je tam dost miesta
    	else if(index>18 && isSpace(oppTrackPos,Math.abs(index-22))&& trackPos>oppTrackPos){
    		launchTrackPos=ourNewTrackPos=sampleTrackPos(launchTrackPos,((trackWidth/2)*oppTrackPos+2.5)/(trackWidth/2));
    		System.out.println(" 5 newtrackpos "+ourNewTrackPos);
    		return 2*(sm.getAngleToTrackAxis()-(sm.getTrackPosition()-ourNewTrackPos))/0.366519;
    	}
    	//oponent je na pravo a neni tam dost miesta	
    	else if(index>18 && !isSpace(oppTrackPos,Math.abs(index-22))&& trackPos>oppTrackPos){
    		launchTrackPos=ourNewTrackPos=sampleTrackPos(launchTrackPos,((trackWidth/2)*oppTrackPos-2.5)/(trackWidth/2));
    		System.out.println(" 6 newtrackpos "+ourNewTrackPos);
    		return 2*(sm.getAngleToTrackAxis()-(sm.getTrackPosition()-ourNewTrackPos))/0.366519;
    	}
    	else if(index>18 && isSpace(oppTrackPos,Math.abs(index-22))&& trackPos<oppTrackPos){
    		launchTrackPos=ourNewTrackPos=sampleTrackPos(launchTrackPos,((trackWidth/2)*oppTrackPos+2.5)/(trackWidth/2));
    		System.out.println(" 7 newtrackpos "+ourNewTrackPos);
    		return 2*(sm.getAngleToTrackAxis()-(sm.getTrackPosition()-ourNewTrackPos))/0.366519;
    	}
    	else if(index>18 && !isSpace(oppTrackPos,Math.abs(index-22))&& trackPos<oppTrackPos){
    		launchTrackPos=ourNewTrackPos=sampleTrackPos(launchTrackPos,((trackWidth/2)*oppTrackPos-2.5)/(trackWidth/2));
    		System.out.println(" 8 newtrackpos "+ourNewTrackPos);
    		return 2*(sm.getAngleToTrackAxis()-(sm.getTrackPosition()-ourNewTrackPos))/0.366519;
    	}
    	else if(index>=18 && isSpace(oppTrackPos,Math.abs(index-22))&& trackPos>oppTrackPos){
    		launchTrackPos=ourNewTrackPos=((trackWidth/2)*oppTrackPos-3.5)/(trackWidth/2);
    		System.out.println(" 5 newtrackpos "+ourNewTrackPos);
    		return 3*(sm.getAngleToTrackAxis()-(sm.getTrackPosition()-ourNewTrackPos)*0.5)/0.366519;
    	}
    	else if(index<=17 && isSpace(oppTrackPos,index-13)&& trackPos<oppTrackPos){
    		launchTrackPos=ourNewTrackPos=((trackWidth/2)*oppTrackPos-3.5)/(trackWidth/2);
    		System.out.println(" 6 newtrackpos "+ourNewTrackPos);
    		return 3*(sm.getAngleToTrackAxis()-(sm.getTrackPosition()-ourNewTrackPos)*0.5)/0.366519;
    	}
    	if(index==17  && isSpace(oppTrackPos,index-13)){
    		launchTrackPos=sm.getTrackPosition();
    		System.out.println("17 true newtrackpos "+launchTrackPos);
    		return 0.5;
    	}
    	if(index==17  && !isSpace(oppTrackPos,index-13)){
    		launchTrackPos=sm.getTrackPosition();
    		System.out.println("17 false newtrackpos "+launchTrackPos);
    		return -0.5;
    	}
    	if(index==18 && isSpace(oppTrackPos,Math.abs(index-22))){
    		launchTrackPos=sm.getTrackPosition();
    		System.out.println("18 true newtrackpos "+launchTrackPos);
    		return 0.5;
    	}
    	if(index==18 && !isSpace(oppTrackPos,Math.abs(index-22))){
    		launchTrackPos=sm.getTrackPosition();
    		System.out.println("18 false newtrackpos "+launchTrackPos);
    		return -0.5;
    	}
    	if(sm.getOpponentSensors()[9]<2.5){
    		launchTrackPos-=0.06;
    	}
    	if(sm.getOpponentSensors()[26]<2.5){
    		launchTrackPos+=0.06;
    	}
    	
    	return 0;
    	
    	
    	
    }*/
	/*//vychadza z predpokladu ze nastranu sa vojdu 2 auta aje tam medzera 30 cm
    private double calculateNewTrackPos(SensorModel sm,double index,double lastindex){
    	double trackPosNew,opponentTrackPos=startingTrackPos;
    	//je pred nami 
    	if( (index==lastindex||index==lastindex)){
    		opponentTrackPos=lastOppPos;
    		System.out.println("1 oponent: "+opponentTrackPos+" index: "+index);
    	//je na pravo	
    	}else if(index >=18){
    		opponentTrackPos=sm.getTrackPosition()-((Math.sin(indexToRad(index,lastindex)+sm.getAngleToTrackAxis())*sm.getOpponentSensors()[(int)index])/(trackWidth/2));
    		System.out.println("2 oponentpos: "+opponentTrackPos+" index: "+index);
    	//je na pravo
    	}else if(index <=17){
    		opponentTrackPos=sm.getTrackPosition()+((Math.sin(indexToRad(index,lastindex)+sm.getAngleToTrackAxis())*sm.getOpponentSensors()[(int)index])/(trackWidth/2));
    		System.out.println("3 oponentpos: "+opponentTrackPos+" index: "+index);
    	}

    	//je vedla eho miesto && sameSide(opponentTrackPos,sm.getTrackPosition())
    	if(isSpace(opponentTrackPos) ){
    		//vypocitam poziciu posunutu od oponenta a preasobim ju znamienkm pre poziciu na trati
    		trackPosNew=((((Math.abs(opponentTrackPos)*(trackWidth/2))+(2.8))/(trackWidth/2))*(Math.abs(opponentTrackPos)/opponentTrackPos));
    		System.out.println("5 : "+(((Math.abs(opponentTrackPos)*(trackWidth/2))+(2.8))/(trackWidth/2) +" dir: "+(Math.abs(opponentTrackPos)/opponentTrackPos)));
    	}
    	//nieje vedla oponenta miesto
    	else if(!isSpace(opponentTrackPos) ){
      		//to iste co hore akuran na druhu stranu oponenta
    		trackPosNew=(((Math.abs(opponentTrackPos)*trackWidth/2-(2.8))/(trackWidth/2)))*(Math.abs(opponentTrackPos)/opponentTrackPos);
    		System.out.println("6 : "+((Math.abs(opponentTrackPos)*trackWidth/2-(2.8))/(trackWidth/2) +" dir: "+(Math.abs(opponentTrackPos)/opponentTrackPos)));
    	}
    	else
    		trackPosNew=launchTrackPos;	
    	
    	lastOppPos=opponentTrackPos;
    	return trackPosNew;
    		
    }*/
	
}
