package controller;

import controller.model.TrackData;
import controller.model.Turn;
import controller.model.Turn.Direction;
import champ2011client.Action;
import champ2011client.SensorModel;

public class LineAssistModul {
	private double targetPosP=0.8;
	private double targetPosM=0.6;
	private double trackWidth;

	public double getTargetPosP() {
		return targetPosP;
	}
	
	public double getTargetPosM() {
		return targetPosM;
	}

	public void setTargetPosP(double targetPos) {
		this.targetPosP = targetPos;
	}
	
	public void setTargetPosM(double targetPos) {
		this.targetPosM = targetPos;
	}

	public double getTrackWidth() {
		return trackWidth;
	}

	public void setTrackWidth(double trackWidth) {
		this.trackWidth = trackWidth;
	}
	
	/**
	 * Metoda ktora upravi steering pred vjazdom do zakruty
	 * @param sm
	 * @param action
	 * @param nextTurn - nasledujuca zakruta
	 * @param lastTurn - predchadzajuca zakruta
	 * @return - action
	 * @author Juraj Kosmel
	 */
	public Action assist(SensorModel sm, Action action, TrackData trackData) {
		//******vjazd do zakruty********//
		 
			if(sm.getDistanceFromStartLine()<trackData.getNextTurn().getEnterKm() && (trackData.getNextTurn().getEnterKm()-sm.getDistanceFromStartLine())<200 && (trackData.getLastTurn()!=null ? ((trackData.getNextTurn().getStartDistance()-trackData.getLastTurn().getEndDistance())>50):true)) {
				
					//System.out.println(sm.getDistanceFromStartLine()+" LINE ASSIST zakruta: "+trackData.getNextTurn().getStartDistance()+" "+trackData.getNextTurn().getPeakValue()); 
					action=navigateToPosition(action,sm, trackData.getNextTurn().getStartDistance(),trackData.getNextTurn().getEnterPos());
					//ladenie trhaneho pohybu
					action.steering=tuneSteering(action.steering);
					/*System.out.println("peak>"+trackData.getNextTurn().getPeakValue());
					System.out.println("dir>"+trackData.getNextTurn().getDirection());
					System.out.println("pos>"+trackData.getNextTurn().getEnterPos());
					System.out.println();*/
			}
		
		//******sustava zakrut********//
		/*if(trackData.getNext2Turn() != null && trackData.getNext2Turn().getDirection() != trackData.getNextTurn().getDirection() && trackData.getNext2Turn().getStartDistance()-trackData.getNextTurn().getEndDistance()<10 && trackData.getNextTurn().getPeakValue()< (trackData.getTrackWidth()>=13 ? 0.3 : 0.2)) {
			if((trackData.getNextTurn().getStartDistance()-sm.getDistanceFromStartLine())>1.8*trackWidth && (trackData.getNextTurn().getStartDistance()-sm.getDistanceFromStartLine())<200) {
				//if((nextTurn.getStartDistance()-lastTurnEnd)>30)
						//System.out.println(sm.getDistanceFromStartLine()+" LINE ASSIST sustava: "+trackData.getNextTurn().getStartDistance()+" "+trackData.getNextTurn().getPeakValue());	
						action=navigateToPosition(action,sm, sm.getDistanceFromStartLine()+100,-trackData.getNextTurn().getEnterPos());
						//ladenie trhaneho pohybu
						action.steering=tuneSteering(action.steering);
			}
		}*/
		
		//vjazd do zakruty
		/*if((trackData.getNextTurn().getEndDistance()-trackData.getNextTurn().getStartDistance())<130 && trackData.getLastTurn()!=null && (trackData.getNextTurn().getStartDistance()-trackData.getLastTurn().getEndDistance())>50 && trackData.getNextTurn().getPeakValue()>(trackData.getTrackWidth()>14 ? 0.3 : 0.2) && sm.getDistanceFromStartLine()>trackData.getNextTurn().getEnterKm() && sm.getDistanceFromStartLine()<(trackData.getNextTurn().getStartDistance()+(trackData.getNextTurn().getEndDistance()-trackData.getNextTurn().getStartDistance())/2.5)) {
			double finPos=0;
			double x = (trackData.getNextTurn().getEndDistance()-trackData.getNextTurn().getStartDistance())/2+(trackData.getTrackWidth()>14 ? 2:1.8)*trackWidth;
			double y = Math.abs(trackData.getNextTurn().getEnterPos())+0.8;
			double pos = sm.getDistanceFromStartLine()-trackData.getNextTurn().getEnterKm();
			double wantPos = (pos/x)*y;
			System.out.println("dlzka: >"+x);
			System.out.println("wantPos: "+wantPos);
			System.out.println("ja: >"+pos+" > "+sm.getTrackPosition());
			if(trackData.getNextTurn().getDirection()==Direction.RIGHT)
				finPos=trackData.getNextTurn().getEnterPos()-wantPos;
			else
				finPos=trackData.getNextTurn().getEnterPos()+wantPos;
			System.out.println("finPos: "+finPos);
			System.out.println();
			action.steering=(sm.getAngleToTrackAxis()-(sm.getTrackPosition()-finPos)*0.5)/0.366519;
			if(trackData.getNextTurn().getDirection()==Direction.RIGHT && action.steering>0)
				if(sm.getTrackPosition()>-0.4)
					action.steering=-0.02;
				else
					action.steering=0;
			if(trackData.getNextTurn().getDirection()==Direction.LEFT && action.steering<0)
				if(sm.getTrackPosition()<0.4)
					action.steering=0.02;
				else
					action.steering=0;
			//System.out.println("steer: "+action.steering);
		}*/
		
		//line assist v zakrute pred dalsou blizkou zakrutou
		/*if(trackData.getNext2Turn()!=null && trackData.getNext2Turn().getPeakValue()>(trackData.getTrackWidth()>13 ? 0.3 : 0.2) && sm.getDistanceFromStartLine()>(trackData.getNextTurn().getEndDistance()-(trackData.getNextTurn().getEndDistance()-trackData.getNextTurn().getStartDistance())/2.5) && sm.getDistanceFromStartLine()<trackData.getNextTurn().getEndDistance()) {
			if(trackData.getNextTurn().getPeakValue()<0.1) {
				action=navigateToPosition(action,sm, trackData.getNext2Turn().getStartDistance(),trackData.getNext2Turn().getEnterPos());
				//System.out.println(sm.getDistanceFromStartLine()+" S_LINE ASSIST: "+trackData.getNextTurn().getStartDistance()+" "+trackData.getNextTurn().getPeakValue()); 
				action.steering=tuneSteering(action.steering);
				//System.out.println("steering: > "+action.steering+" ja: "+sm.getDistanceFromStartLine());
				//System.out.println("next2Turn> start: "+trackData.getNext2Turn().getStartDistance()+" enter: "+trackData.getNext2Turn().getEnterPos());
			}
		}*/
		
		return action;
	}

	/**
	 * Metoda, ktora vypocita uhol medzi aktualnou poziciou auta a bodom na trati pred autom.
	 * @param sm senzory
	 * @param positionDistance vzdialenost sledovaneho bodu od startu
	 * @param position vertikalna pozicia sledovaneho bodu na trati
	 * @return uhol
	 * @author Juraj Kosmel
	 */
	private double computeAngle(SensorModel sm, double positionDistance, double position) { 
		double alfa=0;
		double vertical=0;
		double horizontal=0;
		if((sm.getTrackPosition()>0 && position>0) || (sm.getTrackPosition()<0 && position<0)) { //nasa pozicia aj pozicia kde smerujeme je na rovnakej strane trate
			vertical=Math.abs((trackWidth/2.0)*Math.abs(sm.getTrackPosition())-trackWidth/2.0*Math.abs(position));
			horizontal=positionDistance-sm.getDistanceFromStartLine();
			alfa = Math.atan(vertical/horizontal);
		}
		else {
			vertical=Math.abs((trackWidth/2.0)*Math.abs(sm.getTrackPosition())+trackWidth/2.0*Math.abs(position)); //nasa pozicia a pozicia kde smerujeme su na roznych stranach trate
			horizontal=positionDistance-sm.getDistanceFromStartLine();
			alfa = Math.atan(vertical/horizontal);
		}
		return alfa;
	}
	
	/**
	 * Metoda na upravu smeru jazdy a navigaciu na konkretnu poziciu na trati.
	 * @param action aktualne nastavenie efektorov
	 * @param sm senzory
	 * @param positionDistance pozicia, na ktoru sa chceme dostat - kilometer od zaciatku trate
	 * @param position poloha na trati na danej pozicii
	 * @return upravena action - natocenie kolies
	 * @author Juraj Kosmel
	 */
	private Action navigateToPosition(Action action, SensorModel sm, double positionDistance, double position) {
		double alfa, beta, sum, diff;                                 //uhol natocenia k cielovej pozicii a uhol auta s osou, sucet a rozdiel uhlov
		alfa=computeAngle(sm, positionDistance, position); //vypocet uhla k miestu kde chceme smerovat
		beta = sm.getAngleToTrackAxis();				   //uhol nasho aktualneho smeru
		sum=Math.abs(alfa)+Math.abs(beta);				   //sucet uhlov
		diff=Math.abs(Math.abs(alfa)-Math.abs(beta));				   //rozdiel uhlov
		//System.out.println("beta: "+Math.toDegrees(beta)+" alfa: "+Math.toDegrees(alfa));
		
		if(beta>0) { //som otoceny vpravo
			if(sm.getTrackPosition() >= position) { //chcem ist vpravo vzhladom na moju poziciu
				if(Math.abs(beta)<=alfa) {
					action.steering=-(sum/0.36651943);
					//System.out.println("natoceny vpravo chcem vpravo beta mensia");
				}
				else {
					action.steering=diff/0.36651943;
					//System.out.println("natoceny vpravo chcem vpravo beta vacsia");
				}
			}
			else {								   //chcem ist vlavo vzhladom na moju poziciu
				action.steering=sum/0.36651943;
				//System.out.println("natoceny vpravo chcem vlavo");
			}
		}
		else {		 //som otoceny vlavo
			if(sm.getTrackPosition() >= position) { //chcem ist vpravo vzhladom na moju poziciu
				action.steering=-(sum/0.36651943);
				//System.out.println("natoceny vlavo chcem vpravo");
			}
			else {								   //chcem ist vlavo vzhladom na moju poziciu
				if(Math.abs(beta)<=alfa) {
					action.steering=sum/0.36651943;
					//System.out.println("natoceny vlavo chcem vlavo beta mensia");
				}
				else {
					action.steering=-(diff/0.36651943);
				//	System.out.println("natoceny vlavo chcem vlavo beta vacsia");
				}
			}
		}
		//System.out.println("steering: "+action.steering);
		return action;
	}
	
	/**
	 * ladenie steeringu
	 * @param steer
	 * @return
	 */
	private static double tuneSteering(double steer) {
		//ladenie trhaneho pohybu
		if((steer>0 && steer<0.01) || (steer<0 && steer>-0.01))
			return 0;
		if(steer>0.2)
			return 0.2;
		if(steer<-0.2)
			return -0.2;
		if(Math.abs(steer)>0.1 && Math.abs(steer)<0.2)
			return steer*0.8;
		return steer;
	}
	
	/**
	 * metoda na vypocet rychlosti
	 * @param action
	 * @param sm
	 * @param trackData
	 * @param speedAdjustment
	 * @return
	 */
	public Action getSpeedFromNextTurn(Action action, SensorModel sm, TrackData trackData, double speedAdjustment, double sensorStr) {
		double breakDist=trackData.getNextTurn().getBreakDist();
		//este som v zakrute
		if(sm.getDistanceFromStartLine()<trackData.getNextTurn().getEndDistance() && sm.getDistanceFromStartLine()>trackData.getNextTurn().getStartDistance() && sm.getDistanceFromStartLine()>(trackData.getNextTurn().getStartDistance()+(trackData.getNextTurn().getEndDistance()-trackData.getNextTurn().getStartDistance())/2)) {
			if(trackData.getNext2Turn()!=null && trackData.getNext2Turn().getPeakValue()>(trackData.getTrackWidth()>13 ? 0.2 : 0.15)) {
				breakDist=trackData.getNext2Turn().getBreakDist()+(trackData.getNext2Turn().getStartDistance()-sm.getDistanceFromStartLine());
			}
			else
				breakDist=200;
			//System.out.println("som v zakrute speed <"+breakDist);
		}
		else { //uz som za zakrutou
			if(trackData.getNextTurn()!=null && trackData.getNextTurn().getPeakValue()>(trackData.getTrackWidth()>13 ? 0.15 : 0.1)) {
				breakDist=trackData.getNextTurn().getBreakDist()+(trackData.getNextTurn().getStartDistance()-sm.getDistanceFromStartLine()-4*trackWidth);
			}
			else
				breakDist=200;
			//System.out.println("som pred zakrutou speed <"+breakDist);
		}
		
		if(breakDist<sensorStr);
			breakDist=sensorStr;
		if ((sm.getSpeed() + speedAdjustment) < Math.sqrt(2 * 9.81 * trackData.getFriction() * (Math.abs(breakDist)))){
			action.accelerate = ESP.filterASR(sm, ESP.actionAccelAktual);
			//System.out.println("ESP1 >"+action.accelerate+"  >"+action.accelerate);
			ESP.actionBrakeAktual = 0;
			ESP.actionBrakeTickBack = 0;
		}else if(sm.getSpeed()<20){
			//System.out.println("ESP2 >"+action.accelerate+"  >"+action.accelerate);
			action.accelerate = 0.8;
			ESP.actionBrakeAktual = 0;
			ESP.actionBrakeTickBack = 0;
		}
		else{
			//System.out.println("ESP3 >"+action.accelerate+"  >"+action.accelerate);
			action.brake = ESP.filterABS(sm, ESP.actionBrakeAktual);
			ESP.actionAccelAktual = 0;
			ESP.actionAccelTickBack = 0;
		}
		//System.out.println("breakDist: "+breakDist+" < "+trackData.getNextTurn().getPeakValue());
		return action;
	}
	
}
