package controller;

import java.math.BigDecimal;

import champ2010client.SensorModel;

/**
 * Trieda zhromazdujuca staticke metody sluziace na vypisi a matematicke vypocty.
 * 
 * @author Ivan Valencik
 */
public class Util
{
	public static void dump(SensorModel sm)
	{
		System.out.println("Vypis stavu:\n" +
				"\n- uhol k trati: " + sm.getAngleToTrackAxis() +
				"\n- prevod: " + sm.getGear() +
				"\n- rychlost: " + sm.getSpeed() +
				"\n- lateralna rychlost:" + sm.getLateralSpeed() );
	}

	public static double rollingAverage(double value, double average, double duration)
	{
		return (average * duration + value) / (duration + 1);
	}
	public static double round(double d, int decimalPlace){
		
	    BigDecimal bd = new BigDecimal(Double.toString(d));
	    bd = bd.setScale(decimalPlace,BigDecimal.ROUND_HALF_UP);
	    return bd.doubleValue();
	}
}
