package controller.model;

import java.io.Serializable;
import java.util.Iterator;
import java.util.LinkedList;

import champ2011client.SensorModel;

/**
 * Trieda urcena pre zaznamovanie eventov na trati.
 * 
 * @author Maros Bednar, Marek Bris
 */
public class Event implements Serializable {
	
	public LinkedList<EventInfo> jumps = new LinkedList<EventInfo>();
	public LinkedList<EventInfo> events = new LinkedList<EventInfo>();
	private double jumpDeviationRecord = 100; //odchylka medzi skokmi pri vytvoreni zaznamu
	private double eventDeviationRecord = 100; //odchylka medzi vyjazdami pri vytvoreni zaznamu
	
	private double jumpDeviationApply = 150; //vzdialenost pri aplikovani znizenia rychlosti pri skoku
	private double eventDeviationApply = 100; //vzdialenost pri aplikovani znizenia rychlosti pri vyjazde
		
	private double addSpeed = 10;//hodnota po ktore ma klesat max speed

	private boolean dam=false;
	
	private double maxJump=0;
	private double startJump=0;



	/*
	 * Pridanie skoku do zoznamu
	 */
	public void addJump(double distance, double brake, double actJump)
	{	
		if (maxJump == 0)
			setStartJump(distance);
		
		//System.err.println("start jump "+getStartJump()+" distance "+distance);
		if (actJump > maxJump){
			maxJump=actJump;
			
			int indexJumpu = inList(jumps,distance,jumpDeviationApply,false);
			if (indexJumpu != -1)
				jumps.get(indexJumpu).setMaxJump(maxJump);
			//System.out.println("tu som "+maxJump);
		}
		else if(inList(jumps,getStartJump(),jumpDeviationRecord,false) == -1)
		{	//System.err.println("pridavam jump");
			//System.err.println("start jump "+getStartJump()+" distance "+distance);
			//brake=maxJump*15;
		
			jumps.add(new EventInfo(getStartJump(), brake, maxJump));
			//System.err.println("distance"+distance+" startJump: "+getStartJump());
			//System.out.println("add - jump - brake: "+ jumps.getLast().getBrake());
			//System.out.println("add - jump - distance: "+ jumps.getLast().getDistance());
			setMaxJump(0);
		} else setMaxJump(0);
	}
	
	/*
	 * Pridanie vyjazdu mimo trate do zoznamu
	 */
	public void addEvent(double distance, double brake, Turn actTurn, SensorModel sm)
	{	//System.out.println("--------------->"+distance+" "+actTurn.getStartDistance());
		if ((distance > actTurn.getStartDistance()) && (distance < actTurn.getEndDistance()))
			distance=actTurn.getStartDistance();
		


		if(inList(events,distance,eventDeviationRecord,false) == -1 )
		{	//System.out.println("pridavam event");
			events.add(new EventInfo(distance, brake, -1));
			//System.err.println(sm.getAngleToTrackAxis());
			//System.err.println(sm.getLateralSpeed()+" "+sm.getSpeed());
			//System.out.println("add - event - brake: "+ events.getLast().getBrake());
			//System.out.println("add - event - distance: "+ events.getLast().getDistance());
		}
	}
	
	/*
	 * Vratenie index v pripade ze event/jump s aktualnou polohou sa nachadza v zozname inak -1 
	 */
	public int inList(LinkedList<EventInfo> events, double actualDistance, double deviation, boolean speed)
	{
		int index = 0;
		Iterator it = events.listIterator();

        while(it.hasNext())
        {
          EventInfo event = (EventInfo)it.next();
          if(speed)
          {
        	  if((event.getDistance() - actualDistance) < deviation && (event.getDistance() - actualDistance) > 0)
	          {
	        	  //System.out.println("je v zozname");
	        	  return index; //ak je v zozname
	          }
          }
          else
	          if(Math.abs(actualDistance-event.getDistance()) < deviation)
	          {
	        	  //System.out.println("je v zozname");
				  //setMaxJump(0);
	        	  return index; //ak je v zozname
	          }
          index++;
         
        }
        return -1; // ak nie je v zozname
	}
	
	public double getSpeed(EventInfo actEvent)
	{
		if (actEvent == null)
			return 0;
		else {
			//System.out.println("returnujem "+actEvent.getBrake());
			return actEvent.getBrake();
		}
		
		/*
		int indexEventu = inList(events,actualDistance,eventDeviationApply,true);
		int indexJumpu = inList(jumps,actualDistance,jumpDeviationApply,true);
		
		
		if(indexEventu != -1 && indexJumpu != -1 && !events.isEmpty() && !jumps.isEmpty())
		{
			EventInfo ju = jumps.get(indexJumpu);
			
			//po skoku doslo k vyleteniu
			//System.out.println("brzdi jump: "+ju.getBrake());
			return ju.getBrake();
		}
		else
		{
			if(indexEventu != -1 && !events.isEmpty())
			{
				EventInfo ev = events.get(indexEventu);
				//System.out.println("brzdi event: "+ev.getBrake());
				return ev.getBrake();
				
			}
		}
		return 0;
		*/
	}
	
	public void setSpeed(double actualDistance, SensorModel sm)
	{
		int indexEventu = inList(events,actualDistance,eventDeviationApply,false);
		int indexJumpu = inList(jumps,actualDistance,jumpDeviationApply,false);
		
		if(indexEventu != -1 && indexJumpu != -1 && !events.isEmpty() && !jumps.isEmpty())
		{
			//po skoku doslo k vyleteniu
			EventInfo ju = jumps.get(indexJumpu);
			
			addSpeed=ju.getMaxJump()*15;
			
			jumps.set(indexJumpu, new EventInfo(ju.getDistance(), ju.getBrake()+addSpeed, ju.getMaxJump()));
			
			
			//System.err.println("upravena rychlost "+(ju.getBrake()+addSpeed)+" max jump "+maxJump);
			//System.err.println("vyska "+sm.getZ()+" speed Z: "+sm.getZSpeed());
			setMaxJump(0);

			//System.out.println("setujem jump speed "+ (ju.getBrake()+addSpeed));
			//System.out.println("Ulozena brzda - skok: " + (ju.getBrake()+addSpeed));
			//System.out.println("Ulozena brzda - skok: " + (ju.getDistance()));
		}
		else
		{
			if(indexEventu != -1 && !events.isEmpty())
			{
			//nedoslo po skoku
			EventInfo ev = events.get(indexEventu);
			addSpeed=Math.abs(sm.getLateralSpeed()/5.0); // 5.0 bulharska konstanta


			//System.out.println("setujem pred event speed "+ (ev.getBrake()+addSpeed));
			//System.err.println("uhol: "+sm.getAngleToTrackAxis());
			//System.err.println("damage "+sm.getDamage());

			if (sm.getDamage()>800 && !dam) {
				addSpeed=80;
				dam=true;
			}
			
			//System.err.println("lateral: "+sm.getLateralSpeed()+" normal: "+sm.getSpeed());
			
			events.set(indexEventu, new EventInfo(ev.getDistance(), ev.getBrake()+addSpeed, -1));			
			
			//System.out.println("setujem pred event speed "+ (ev.getBrake()+addSpeed));
			//System.out.println("Ulozena brzda - event: " + (ev.getBrake()+addSpeed));
			//System.out.println("Ulozena brzda - event: " + (ev.getDistance()));
			} 
			
			setMaxJump(0);
				
		}
		
		
	}
	
	
	public LinkedList<EventInfo> getJumps() {
		return jumps;
	}

	public LinkedList<EventInfo> getEvents() {
		return events;
	}

	public void setJumps(LinkedList<EventInfo> jumps) {
		this.jumps = jumps;
	}

	public void setEvents(LinkedList<EventInfo> events) {
		this.events = events;
	}
	
	public double getAddSpeed() {
		return addSpeed;
	}

	public void setAddSpeed(double addSpeed) {
		this.addSpeed = addSpeed;
	}
	
	public double getMaxJump() {
		return maxJump;
	}

	public void setMaxJump(double lastJump) {
		this.maxJump = lastJump;
	}
	
	public double getStartJump() {
		return startJump;
	}

	public void setStartJump(double startJump) {
		this.startJump = startJump;
	}
 
}
